"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// import 'core-js/stable';
// import 'regenerator-runtime/runtime';
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var express_1 = __importDefault(require("express"));
var FileFunctionServer = /** @class */ (function () {
    function FileFunctionServer(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.app, app = _c === void 0 ? express_1.default() : _c, _d = _b.functionsDir, functionsDir = _d === void 0 ? path_1.default.join(process.env.PWD || process.cwd(), '/functions') : _d, _e = _b.port, port = _e === void 0 ? process.env.PORT || 9000 : _e;
        this.app = app;
        this.fnDir = functionsDir;
        this.attachFunctionsEndpoint();
        this.port = +port;
    }
    /**
     * start
     */
    FileFunctionServer.prototype.start = function () {
        var _this = this;
        this.app.listen(this.port, function () {
            return console.log("running on http://localhost:" + _this.port);
        });
    };
    FileFunctionServer.prototype.formatFunctionName = function (name) {
        return name.split('.')[0];
    };
    FileFunctionServer.prototype.attachFunctionsEndpoint = function () {
        var _this = this;
        this.app.get('/functions', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            var fns;
            var _this = this;
            return __generator(this, function (_a) {
                fns = fs_1.default.readdirSync(this.fnDir);
                return [2 /*return*/, res.send(/* HTML */ "\n\t\t\t\t<h1>Functions:</h1>\n\t\t\t\t<ul>\n\t\t\t\t\t" + fns
                        .map(function (fn) {
                        fn = _this.formatFunctionName(fn);
                        return "<li>\n\t\t\t\t\t\t\t\t\t<a href=\"/functions/" + fn + "\">" + fn + "</a>\n\t\t\t\t\t\t\t\t</li>";
                    })
                        .join('') + "\n\t\t\t\t</ul>\n\t\t\t")];
            });
        }); });
        this.app.use('/functions/*', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            var fnName, fnModule, fnHandler, body, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fnName = this.formatFunctionName(req.originalUrl.split('/functions')[1]);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        fnModule = void 0;
                        try {
                            fnModule = require(path_1.default.relative(__dirname, path_1.default.join(this.fnDir, fnName)));
                        }
                        catch (e) { }
                        if (!fnModule) {
                            res.status(404);
                            return [2 /*return*/, res.send("file/folder not found for function " + fnName)];
                        }
                        fnHandler = fnModule.default;
                        if (!fnHandler) {
                            res.status(404);
                            return [2 /*return*/, res.send("handler not found in file/folder for function " + fnName)];
                        }
                        console.log(/* template */ "running function: " + fnName);
                        return [4 /*yield*/, fnHandler(req, res)];
                    case 2:
                        body = _a.sent();
                        res.send(body);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.log(e_1);
                        res.status(500);
                        res.send('failed');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    };
    return FileFunctionServer;
}());
exports.FileFunctionServer = FileFunctionServer;
